//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <string>
#include "ucl/file.hpp"
#include "FrmMainUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFrmMain *FrmMain;


std::string extractFilePath (const std::string& path)
{
	int i;

	for (i = path.size () - 1; (path[i] != '\\') && (i > 0); --i)
		;
	if (path[i] == '\\')
		++i;
	
	return (path.substr (0, i));
}

std::string getExePath (void)
{
	char exepath[1024];
	int i;

	GetModuleFileName (NULL, exepath, 1024);
	
	return (extractFilePath (exepath));
}

//---------------------------------------------------------------------------
__fastcall TFrmMain::TFrmMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFrmMain::FormCreate(TObject *Sender)
{
		// make window stay always on top (within the SIM)
	SetWindowPos (Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
}
//---------------------------------------------------------------------------
void __fastcall TFrmMain::BtnExitSIMClick(TObject *Sender)
{
	ucl::IniFile settings;
	HWND hSIMWin;
	DWORD waittime;

	
	waittime = settings["Settings"]["DelayTime"].asInteger ();

	hSIMWin = FindWindow ("TMainForm", ("SIM3022 - " + settings["Settings"]["SIMPath"].asString () + "SIM\\obimport.cpj").c_str ());
	if (!hSIMWin)
	{
		char buf[512];
		hSIMWin = FindWindow ("TMainForm", NULL);
		if (!hSIMWin)
		{
			Application->MessageBox ("Error: SIM window not found", "Error", MB_ICONERROR);
			Close ();
			return;
		}
		
		GetWindowText (hSIMWin, buf, 512);
		buf[7] = '\0';
		if (strcmp (buf, "SIM3022"))
		{
			Application->MessageBox ("Error: SIM window not found", "Error", MB_ICONERROR);
			Close ();
			return;
		}
	}
		

	SetWindowPos (hSIMWin, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

	keybd_event (VK_ESCAPE, 0, 0, 0); /* ESC */
	keybd_event (VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0);

	Sleep (100);
	
	keybd_event (VK_MENU, 0, 0, 0); /* Alt+F */
	keybd_event ('F', 0, 0, 0);
	keybd_event ('F', 0, KEYEVENTF_KEYUP, 0);
	keybd_event (VK_MENU, 0, KEYEVENTF_KEYUP, 0);

	keybd_event ('C', 0, 0, 0); /* C */
	keybd_event ('C', 0, KEYEVENTF_KEYUP, 0);

	Sleep (100);
	
	keybd_event ('N', 0, 0, 0); /* N */
	keybd_event ('N', 0, KEYEVENTF_KEYUP, 0);
	
	keybd_event (VK_MENU, 0, 0, 0); /* Alt+F4 */
	keybd_event (VK_F4, 0, 0, 0);
	keybd_event (VK_F4, 0, KEYEVENTF_KEYUP, 0);
	keybd_event (VK_MENU, 0, KEYEVENTF_KEYUP, 0);

	Visible = false;
	
	Sleep (waittime);

	Close ();
}
//---------------------------------------------------------------------------
