//---------------------------------------------------------------------------

//#include <iostream>
#include <string>
#include <fstream>
#include <windows.h>
#pragma hdrstop

//---------------------------------------------------------------------------

using namespace std;


void create_charmap (void)
{
	fstream ofile, cfile;
	int n;
	unsigned int c;

	unsigned char ansi2pv[256];
	bool registered[256];


	for (n = 0; n < 256; ++n)
	{
		ansi2pv[n] = ' ';
		registered[n] = false;
    }
	 
	  /* charmap file created on PV, exported with TWF2CSV */
	cfile.open ("charmap.txt", ios::in);
	ofile.open ("charmap.c", ios::out);


		/* create pv2ansi table */
	ofile << "const unsigned char charmap_pv2ansi[] = {\n    ";
	for (n = 0; n < 32; ++n)
	{
		ofile << (((n == 0x0A) || (n == 0x0D)) ? "10, " : "0, ");
		if (((n + 1) % 8) == 0)
			ofile << "\n    ";
	}

	cfile.seekg (9, ios::beg); /* skip "Charmap" */
	for (n = 32; n < 256; ++n)
	{
		c = cfile.get ();
		cfile.get (); /* skip '\n' */

		if (!registered[c])
			ansi2pv[c] = n;
		registered[c] = true;
		 
		ofile << c
			  << " /*" << static_cast <char> (c) << "*/, ";
		if (((n + 1) % 8) == 0)
			ofile << "\n    ";
	}
	ofile << "};\n\n";


		/* create ansi2pv table */
	ofile << "const unsigned char charmap_ansi2pv[] = {\n    ";
	for (n = 0; n < 32; ++n)
	{
		ofile << (((n == 0x0A) || (n == 0x0D)) ? "13, " : "0, ");
		if (((n + 1) % 8) == 0)
			ofile << "\n    ";
	}

	for (n = 32; n < 256; ++n)
	{
		ofile << static_cast <unsigned int> (ansi2pv[n])
			  << " /*" << static_cast <char> (n) << "*/, ";
		if (((n + 1) % 8) == 0)
			ofile << "\n    ";
	}
	ofile << "};\n";


	cfile.close ();
	ofile.close ();
}


#pragma argsused
int main(int argc, char* argv[])
{
	create_charmap ();
	return (0);
}
//---------------------------------------------------------------------------
