//---------------------------------------------------------------------------

#include <string>
#include <iostream>
#pragma hdrstop

#include "ucl/file.hpp"

//---------------------------------------------------------------------------


using namespace std;


string ifname, ofname;
string projname;


string intToString (int i, int radix = 10)
{
	char buf[33+1];

	return (itoa (i, buf, radix));
}

void syntaxMessage (void)
{
	cout << endl << endl
		 << "Syntax: cpr2obp <.cpr file> <program name> [<.obp file>]" << endl << endl;	
}


#pragma argsused
int main (int argc, char* argv[])
{
	ucl::IniFile ifile, ofile;
	int cnt, n;


	cout << "cpr2obp v1.01 (c) 2006 by AUDACIA Software" << endl
		 << "Converts ConTEXT projects to owb2sim projects" << endl;

	if (argc <= 1) // no arguments given
	{
		syntaxMessage ();
		return (0);
	}
	ifname = argv[1];

	if (argc <= 2) // no program name given - user input
	{
		cout << "Program name: ";
		cin >> projname;
	}
	else
		projname = argv[2];

	if (argc <= 3) // no output file given - save to same directory as input file
		ofname = ucl::extractFilePath (ifname) + ucl::extractFileName (ifname) + ".obp";
	else
		ofname = argv[3];
	if (ucl::extractFileExt (ifname).empty ())
		ifname += ".cpr";

	ifile.loadFromFile (ifname);

	if (ifile["General"]["Signature"].asString () != "ConTEXT project file")
	{
		cerr << "Error: Invalid .cpr file" << endl;
		return (1);
	}
	ofile["Settings"]["Progname"] = projname;
	ofile["Settings"]["ProjectFormatVersion"] = intToString (120);
	/*ofile["Settings"]["Category"] = intToString (5);*/

	cnt = ifile["General"]["FilesCount"].asInteger ();
	for (n = 1; n <= cnt; ++n)
		ofile["Category 5"].addLine (ifile["File" + intToString (n)]["Name"]);

	if (!ofile.saveToFile (ofname))
	{
		cerr << "Error: unable to write .obp file" << endl;
		return (1);
	}

	cout << "File successfully converted" << endl;
	
	return (0);
}
//---------------------------------------------------------------------------
