; OWBasic Emulator Toolkit - Installer Script
; (c) 2006 by AUDACIA Software



[Setup]
AppName=OWBasic Emulator Toolkit
AppVerName=OWBasic Emulator Toolkit v1.01
DefaultDirName={pf}\AUDACIA\OWBasic Emulator Toolkit
DefaultGroupName=AUDACIA Software\OWBasic Emulator Toolkit

AllowRootDirectory=true
AllowNoIcons=true
AlwaysShowDirOnReadyPage=true
AlwaysShowGroupOnReadyPage=true

AppPublisher=AUDACIA Software
AppPublisherURL=http://www.audacia-software.de/
AppVersion=1.01
AppId={{5343EF38-87EF-4AAB-8DE7-18932BBFF422}
AppCopyright=(c) 2006 by AUDACIA Software

ChangesAssociations=true

LicenseFile=licenseEN.rtf
Uninstallable=true
InternalCompressLevel=ultra
VersionInfoVersion=1.01
VersionInfoCompany=AUDACIA Software
VersionInfoCopyright=(c) 2006 by AUDACIA Software
InfoBeforeFile=info.rtf
ShowLanguageDialog=yes
UninstallDisplayName=OWBasic Emulator Toolkit



[Types]
Name: full; Description: Full installation
Name: custom; Description: Custom installation; Flags: iscustom



[Components]
Name: main; Description: Program Files; Types: full custom; Flags: fixed
Name: sim; Description: Simulator Files; Types: full custom; Flags: fixed
Name: osl; Description: OSL v1.2 Files; Types: full custom
Name: example; Description: Example Project; Types: full custom



[Tasks]
Name: obpext; Description: .OBP file &associations
Name: twfext; Description: "Add ""&Start in Simulator"" Context Menu entry for .TWF files"
Name: ctxext; Description: Create ConTEXT Key Command for .OBP files



[Dirs]
Name: {app}\projects; Components: example
Name: {app}\projects\PocketPaint; Components: example
Name: {app}\lib; Components: osl
Name: {app}\lib\OSL; Components: osl



[Files]
Source: files\simfiles\*; DestDir: {code:getSimPath}; Flags: recursesubdirs createallsubdirs uninsneveruninstall; Components: sim
Source: files\main\*; DestDir: {app}; Components: main
Source: files\example\*; DestDir: {app}\projects\PocketPaint; Components: example
Source: files\osl\*; DestDir: {app}\lib\OSL; Components: osl



[Icons]
Name: {group}\Command Line; Filename: {cmd}; WorkingDir: {app}; Components: ; Tasks: ; Comment: OWBasic Emulator Toolkit Command Line; IconFilename: {cmd}
Name: {group}\twf2obp; Filename: {app}\twf2obp.exe; WorkingDir: {app}; IconFilename: {app}\twf2obp.exe; Components: ; Tasks: ; Comment: TWF file to owb2sim Project File Converter
;Name: {group}\ProjMan; Filename: {app}\projman.exe; WorkingDir: {app}; IconFilename: {app}\projman.exe; Components: ; Tasks: ; Comment: owb2sim Project Manager
Name: {group}\Uninstall OWBasic Emulator Toolkit; Filename: {uninstallexe}; WorkingDir: {app}; IconFilename: {uninstallexe}; Comment: Uninstalls the OWBasic Emulator Toolkit



[Registry]
Root: HKLM; Subkey: Software\AUDACIA; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: Software\AUDACIA\OWBasic Emulator Toolkit; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: Software\AUDACIA\OWBasic Emulator Toolkit; ValueType: string; ValueName: InstallPath; ValueData: {app}; Flags: uninsdeletevalue
Root: HKLM; Subkey: Software\AUDACIA\OWBasic Emulator Toolkit; ValueType: dword; ValueName: Version; ValueData: 101; Flags: uninsdeletevalue

Root: HKCR; Subkey: .twf; ValueType: string; ValueData: {reg:HKCR\.twf,|SFIWIN_File}; Tasks: twfext
Root: HKCR; Subkey: {reg:HKCR\.twf,|SFIWIN_File}; Flags: uninsdeletekeyifempty; Tasks: twfext
Root: HKCR; Subkey: {reg:HKCR\.twf,|SFIWIN_File}\shell; Flags: uninsdeletekeyifempty; Tasks: twfext
Root: HKCR; Subkey: {reg:HKCR\.twf,|SFIWIN_File}\shell\run; ValueType: string; ValueData: Start in Simulator; Flags: uninsdeletekeyifempty; Tasks: twfext
Root: HKCR; Subkey: {reg:HKCR\.twf,|SFIWIN_File}\shell\run\command; ValueType: string; ValueData: """{app}\twf2obp.exe"" -r ""%1"""; Flags: uninsdeletekeyifempty; Tasks: twfext

Root: HKCR; Subkey: .obp; ValueType: string; ValueData: owb2sim_projfile; Flags: uninsdeletekeyifempty; Tasks: obpext
Root: HKCR; Subkey: owb2sim_projfile; ValueType: string; ValueData: owb2sim Project file; Flags: uninsdeletekeyifempty; Tasks: obpext
Root: HKCR; Subkey: owb2sim_projfile\shell; Flags: uninsdeletekeyifempty; Tasks: obpext
Root: HKCR; Subkey: owb2sim_projfile\shell\open; Flags: uninsdeletekeyifempty; Tasks: obpext
Root: HKCR; Subkey: owb2sim_projfile\shell\open\command; ValueType: string; ValueData: "{reg:HKCR\ConTEXT Project\Shell\Open\Command,|""{win}\notepad.exe"" ""%251""}"; Flags: uninsdeletekeyifempty; Tasks: obpext

Root: HKCR; Subkey: {code:getConTEXTKeyName} ValueType: string; ValueData: obp; Tasks: ctxext; AfterInstall: writeConTEXTCmdEntry



[Code]
const
	conTEXTBaseKey = 'Software\Eden\ConTEXT';
	conTEXTCmdKey = 'Software\Eden\ConTEXT\UserExecKeys';
	defaultSIMPath = 'C:\CASIO\PV2EN03';
	SIMKey = 'SOFTWARE\CASIO COMPUTER CO.,LTD\PV2SDK-EN03';

	msgSIMNotFound = 'PV2SDK-EN03 not found.'#13#10 + 'Please install PV2SDK-EN03 before installing OWBasic Emulator Toolkit.';
	msgSIMPathPrompt = 'Please select PV2SDK-EN03 directory:';

var
	simpath : String;
	ctxkey  : DWord;


function InitializeSetup () : Boolean;
begin
	simpath := '';
	ctxkey  := $FFFFFFFF;

	result := RegKeyExists (HKEY_LOCAL_MACHINE, SIMKey);
	if not result then
		MsgBox (msgSIMNotFound, mbError, MB_OK)
end;


function getSimPath (Param : String) : String;
begin
	if simpath = '' then
	begin
		simpath := defaultSIMPath;
		if not BrowseForFolder (msgSIMPathPrompt, simpath, true) then
			Abort;
	end;
	result := simpath;
end;


function getConTEXTKeyName (Param : String) : String;
var
	dw	   : DWord;
	n, cnr : Integer;
	newkey : Boolean;
	str : String;
begin
	newkey := true;
	result := conTEXTCmdKey + '\' + IntToStr (ctxkey);

	if ctxkey <> $FFFFFFFF then
		exit;
	if not RegKeyExists (HKEY_CURRENT_USER, conTEXTBaseKey) then
	begin
		MsgBox ('ConTEXT was not found on your system.'#13#10
		      + 'Therefore, Setup is unable to create a Key Command for .OBP files.', mbError, MB_OK);
		exit;
	end;
	if Pos ('ctxext', WizardSelectedTasks (false)) = 0 then
		exit;

	RegQueryDWordValue (HKEY_CURRENT_USER, conTEXTCmdKey, 'Count', dw);
	cnr := dw;
	for n := 0 to cnr - 1 do
	begin
		RegQueryStringValue (HKEY_CURRENT_USER, conTEXTCmdKey + '\' + IntToStr (n), 'Extensions', str);
		if str = 'obp' then // entry found - overwrite
		begin
			ctxkey := n;
			newkey := false;
			break;
		end;
	end;
	if newkey then
	begin
		RegWriteDWordValue (HKEY_CURRENT_USER, conTEXTCmdKey, 'Count', cnr + 1);
		ctxkey := cnr;
	end;
	result := conTEXTCmdKey + '\' + IntToStr (ctxkey);
end;


procedure writeConTEXTCmdEntry ();
var
	str : String;
begin
  if ctxkey = $FFFFFFFF then
    exit;
	str := getConTEXTKeyName ('');
	RegWriteStringValue (HKEY_CURRENT_USER, str, 'Extensions', 'obp');
	str := str + '\F9';
	RegWriteDWordValue  (HKEY_CURRENT_USER, str, 'CaptureOutput', 1);
	RegWriteStringValue (HKEY_CURRENT_USER, str, 'ExecCommand', ExpandConstant ('{app}') + '\owb2sim.exe');
	RegWriteStringValue (HKEY_CURRENT_USER, str, 'Hint', '');
	RegWriteStringValue (HKEY_CURRENT_USER, str, 'Params', '%f');
	RegWriteStringValue (HKEY_CURRENT_USER, str, 'ParserRule', '*%n,%l:');
	RegWriteDWordValue  (HKEY_CURRENT_USER, str, 'SaveMode', 1);
	RegWriteDWordValue  (HKEY_CURRENT_USER, str, 'ScrollConsole', 1);
	RegWriteStringValue (HKEY_CURRENT_USER, str, 'StartDir', '%p');
	RegWriteDWordValue  (HKEY_CURRENT_USER, str, 'UseShortName', 0);
	RegWriteDWordValue  (HKEY_CURRENT_USER, str, 'Window', 0);
end;
