//---------------------------------------------------------------------------
#define NO_WIN32_LEAN_AND_MEAN
#include <vcl.h>
#include <shlobj.h>
#include <ole2.h>
#include "Twfdec.hpp"
#pragma hdrstop

#include "twf2obp_u1.h"

bool createProjectFile (const char* path, AnsiString& projfile, bool cmdline);


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFrmMain *FrmMain;
//---------------------------------------------------------------------------
__fastcall TFrmMain::TFrmMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFrmMain::BtnExitClick(TObject *Sender)
{
    Close ();    
}
//---------------------------------------------------------------------------

void __fastcall TFrmMain::BtnAboutClick(TObject *Sender)
{
	Application->MessageBox ("twf2obp v1.01\n"
      "TWF file to owb2sim project converter\n\n"
	  "(c) 2006 by AUDACIA Software\n"
	  "www.audacia-software.de\n\n"
	  "TWF export module based on TWF2CSV by Zoltan Babos",
	  "About twf2obp", MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------

void __fastcall TFrmMain::BtnTWFFileClick(TObject *Sender)
{
    if (!OpdTWFFile->Execute ())
        return;
    EdtTWFFile->Text = OpdTWFFile->FileName;
}
//---------------------------------------------------------------------------

void __fastcall TFrmMain::BtnWritePathClick(TObject *Sender)
{
    BROWSEINFO bi;
    char buf[MAX_PATH];
    PItemIDList piidl;

  
    bi.hwndOwner      = Handle;
    bi.pidlRoot       = NULL;
    bi.pszDisplayName = buf;
    bi.lpszTitle      = "Please select output directory:";
    bi.ulFlags        = BIF_EDITBOX | BIF_NEWDIALOGSTYLE;
    bi.lpfn           = NULL;

    OleInitialize (NULL);
    CoInitialize (NULL);
    piidl = SHBrowseForFolder (&bi);
    if (piidl)
        if (SHGetPathFromIDList (piidl, buf))
            EdtWritePath->Text = buf;
    CoUninitialize ();
    OleUninitialize ();
}
//---------------------------------------------------------------------------


static __stdcall void printMessage (char* text, int i)
{
    if (std::strncmp (text, "Error", 5) == 0)
    {
        *reinterpret_cast <bool*> (i) = false;
        Application->MessageBox (text, "Error", MB_ICONERROR);
    }
}


void __fastcall TFrmMain::BtnConvertClick(TObject *Sender)
{
    bool success = true;
    AnsiString projfile;


    decodeTWFFile (EdtWritePath->Text.c_str (), EdtTWFFile->Text.c_str (),
                   twfMemo, decTXT | decSingleMemo | decOWBExtensions,
                   printMessage, reinterpret_cast <int> (&success));

    if (!success)
        return;

    createProjectFile ((EdtWritePath->Text + '\\').c_str (), projfile, false);
    Application->MessageBox ("Project file created successfully.",
                             "Operation performed", MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------

