
#ifndef _BINFILE_H
#define _BINFILE_H

#include <vector>
#include <string>


namespace ucl
{

typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned int   dword;


class BinFile
{
protected:
    bool load_internal (const std::string& filename) const;
    mutable std::vector <byte> _data;

public:
    //enum hexmode_t {hex16Bit, hex32Bit};

    std::vector <byte>& data;

    BinFile (void)
     : data (_data)
    { }
    BinFile (const std::string& filename)
     : data (_data)
    { load_internal (filename); }
    BinFile (const BinFile& bf)
     : _data (bf._data), data (_data)
    { }

    const BinFile& operator = (const BinFile& bf)
    { _data = bf._data; return (*this); }
    
    bool loadFromFile (const std::string& filename)
    { return (load_internal (filename)); }
    bool saveToFile (const std::string& filename) const;
    bool loadFromHexFile (const std::string& filename);
    bool saveToHexFile (const std::string& filename) const;
};



} /* namespace ucl */

#endif
